org.eclipse.jetty.jndi

## Class ContextFactory

- java.lang.Object
- - org.eclipse.jetty.jndi.ContextFactory

- All Implemented Interfaces:
    ObjectFactory

      public class ContextFactory
      extends Object
      implements ObjectFactory

  ContextFactory.java This is an object factory that produces a jndi naming context based on a classloader. It is used for the java:comp context. This object factory is bound at java:comp. When a lookup arrives for java:comp, this object factory is invoked and will return a context specific to the caller's environment (so producing the java:comp/env specific to a webapp). The context selected is based on classloaders. First we try looking at the thread context classloader if it is set, and walk its hierarchy, creating a context if none is found. If the thread context classloader is not set, then we use the classloader associated with the current Context. If there is no current context, or no classloader, we return null. Created: Fri Jun 27 09:26:40 2003

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ContextFactory()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `dump(Appendable out, String indent)`
    `Context` | `getContextForClassLoader(ClassLoader loader)` Find the naming Context for the given classloader
    `Object` | `getObjectInstance(Object obj, Name name, Context nameCtx, Hashtable env)` Find or create a context which pertains to a classloader.
    `NamingContext` | `newNamingContext(Object obj, ClassLoader loader, Hashtable env, Name name, Context parentCtx)` Create a new NamingContext.
    `static void` | `resetComponentContext(Context ctx)` Set back the context with the given value.
    `static Context` | `setComponentContext(Context ctx)` Associate the given Context with the current thread.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ContextFactory

          public ContextFactory()

  - ### Method Detail

    - #### getObjectInstance

          public Object getObjectInstance(Object obj,
                                 Name name,
                                 Context nameCtx,
                                 Hashtable env)
                                   throws Exception

      Find or create a context which pertains to a classloader. If the thread context classloader is set, we try to find an already-created naming context for it. If one does not exist, we walk its classloader hierarchy until one is found, or we run out of parent classloaders. In the latter case, we will create a new naming context associated with the original thread context classloader. If the thread context classloader is not set, we obtain the classloader from the current jetty Context, and look for an already-created naming context. If there is no current jetty Context, or it has no associated classloader, we return null.
      Specified by:
        `getObjectInstance` in interface `ObjectFactory`
      Throws:
        `Exception`
      See Also:
        `ObjectFactory.getObjectInstance(java.lang.Object, javax.naming.Name, javax.naming.Context, java.util.Hashtable)`

    - #### newNamingContext

          public NamingContext newNamingContext(Object obj,
                                       ClassLoader loader,
                                       Hashtable env,
                                       Name name,
                                       Context parentCtx)
                                         throws Exception

      Create a new NamingContext.
      Parameters:
        `obj` -
        `loader` -
        `env` -
        `name` -
        `parentCtx` -
      Returns:
      Throws:
        `Exception`

    - #### getContextForClassLoader

          public Context getContextForClassLoader(ClassLoader loader)

      Find the naming Context for the given classloader
      Parameters:
        `loader` -
      Returns:

    - #### setComponentContext

          public static Context setComponentContext(Context ctx)

      Associate the given Context with the current thread. resetComponentContext method should be called to reset the context.
      Parameters:
        `ctx` - the context to associate to the current thread.
      Returns:
        the previous context associated on the thread (can be null)

    - #### resetComponentContext

          public static void resetComponentContext(Context ctx)

      Set back the context with the given value. Don't return the previous context, use setComponentContext() method for this.
      Parameters:
        `ctx` - the context to associate to the current thread.

    - #### dump

          public static void dump(Appendable out,
                  String indent)
                           throws IOException

      Throws:
        `IOException`

Copyright © 1995-2015 Mort Bay Consulting. All Rights Reserved.